/*

B-Free Project ʪ GNU Generic PUBLIC LICENSE ˽ޤ

GNU GENERAL PUBLIC LICENSE
Version 2, June 1991

(C) B-Free Project.

*/
/* $Header: /cvsroot/bfree-info/B-Free/Program/btron-pc/boot/2nd/vga.h,v 1.1 2011/12/27 17:13:35 liu1 Exp $ */

/*
 * $Log: vga.h,v $
 * Revision 1.1  2011/12/27 17:13:35  liu1
 * Initial Version.
 *
 * Revision 1.4  2000-02-27 03:18:13  monaka
 * Graphics functions are deleted.
 *
 * Revision 1.3  1999/03/15 01:35:35  monaka
 * Minor modify. Function printf was renamed to boot_printf. Some cast was added. and so on.
 *
 * Revision 1.2  1998/11/20 08:02:41  monaka
 * *** empty log message ***
 *
 * Revision 1.1  1997/08/31 14:22:45  night
 * ǽϿ
 *
 *
 * 
 */


#ifndef __VGA_H__
#define __VGA_H__


/*
 * Ƽ쥸Υɥ쥹
 */
#define    ATTRREG    0x3C0
#define    MISCREG    0x3C2
#define    SEQUREG    0x3C4
#define    GRAPHREG   0x3CE
#define    CRTCREG    0x3D4
#define    STATREG    0x3DA


#define VGA_GR_INDEX_PORT		0x3CE
#define VGA_SR_INDEX_PORT		0x3C4

#define VGA_VRAM_ADDRESS		0xA0000


/* Sequencer register Υѥ᡼ */
#define SR_MAP_MASK			0x02

/* Graphics controller register Υѥ᡼ */
#define	VGA_SET_RESET			0x00
#define	VGA_ENABLE_SET_RESET		0x01
#define	VGA_COLOR_COMP			0x02
#define	VGA_FUNCTION			0x03
#define	VGA_READ_MAP_SELECT		0x04
#define	VGA_MODE				0x05
#define	VGA_MISC				0x06
#define	VGA_CDONT_CARE			0x07
#define	VGA_BIT_MASK			0x08

/*
	VGA_SET_RESET,	VGA_ENABLE_SET_RESET register Υѥ᡼ 
*/
#define	VGA_PLANE1			0x01
#define	VGA_PLANE2			0x02
#define	VGA_PLANE3			0x04
#define	VGA_PLANE4			0x08

/* VGA_FUNCTION register Υѥ᡼ */
#define	VGA_OVERWRITE			0x00
#define	VGA_AND				0x10
#define	VGA_OR				0x20
#define	VGA_XOR				0x30

/* VGA_MODE register Υѥ᡼ */
#define	VGA_WM0				0x00
#define	VGA_WM1				0x01
#define	VGA_WM2				0x02
#define	VGA_WM3				0x03
#define	VGA_RD0				0x00
#define	VGA_RD1				0x08

/* ӥåȥڥ졼 */
#define	MakeMask(index)		(1 << (index))
#define	BitTest(data,index)	((data) & MakeMask (index))

/* ɥ쥹׻ */
#define	P2G(x,y)	((y) * 80 + (x))

extern int	vga_text (void);

#ifdef BOOT_USE_VGA_GRAPH
extern void	vga_graph (void);

extern void	clear_vga (int color);
extern void	point_vga (ULONG x, ULONG y, int color, int rastop );
extern void	line_vga (int x0, int x1, int y0, int y1 ,int color, int mode);
extern void	stick_bitmap (int x, int y, int x_length, int y_length, unsigned char *bitmap, int color, int bkcolor);
#endif


#endif /* __VGA_H__ */

