/*

B-Free Project ʪ GNU Generic PUBLIC LICENSE ˽ޤ

GNU GENERAL PUBLIC LICENSE
Version 2, June 1991

(C) B-Free Project.

*/

static char	rcsid[] = "@(#)$Id: posix.c,v 1.1 2011/12/27 17:13:35 liu1 Exp $";


/* posix.c - POSIX Ķޥ͡
 *
 *
 *
 * $Log: posix.c,v $
 * Revision 1.1  2011/12/27 17:13:35  liu1
 * Initial Version.
 *
 * Revision 1.21  2000-04-03 14:32:33  naniwa
 * minor fix
 *
 * Revision 1.20  2000/02/19 03:02:14  naniwa
 * minor change on debug write
 *
 * Revision 1.19  2000/01/26 08:24:34  naniwa
 * to prevent memory leak
 *
 * Revision 1.18  1999/03/15 08:39:24  monaka
 * Some fixes for using dbg_printf().
 *
 * Revision 1.17  1997/10/24 13:58:14  night
 * ¹Գϻ init_malloc () ƤӽФ褦ˤ
 *
 * Revision 1.16  1997/09/21 13:34:11  night
 * 饤֥ malloc ޥѤʤ褦ˤ
 *
 * Revision 1.15  1997/08/31 13:30:57  night
 * ǥХåѽϤΰ #ifdef DEBUG ... #endif ǿϤ
 *
 * Revision 1.14  1997/07/06 11:56:41  night
 * malloc ǽνɲá
 *
 * Revision 1.13  1997/07/04 15:07:39  night
 * ڥե - ǥХɥ饤ХݡȤбɽδϢɲá
 * եɤ߹߽β
 *
 * Revision 1.12  1997/07/03 14:24:30  night
 * mountroot/open ΥХ
 *
 * Revision 1.11  1997/05/08 15:11:29  night
 * ץξꤹ뵡ǽɲá
 * (syscall misc  proc_set_info ޥ)
 *
 * Revision 1.10  1997/04/28 15:28:18  night
 * ǥХåѤʸɲá
 *
 * Revision 1.9  1997/04/24 15:40:30  night
 * mountroot ƥॳμԤä
 *
 * Revision 1.8  1997/03/25 15:45:23  night
 * ǥХåѤɲä̵¥롼ʸ(λߤ褦ˤƤ)
 * 
 *
 * Revision 1.7  1997/03/25 13:34:53  night
 * ELF μ¹ԥեؤб
 *
 * Revision 1.6  1996/11/20  12:09:54  night
 * rcsid ɲá
 *
 * Revision 1.5  1996/11/11  13:37:06  night
 * ɲ
 *
 * Revision 1.4  1996/11/10  11:54:27  night
 * ƥॳؿ˥ꥯȾϤȤˡݥϤǤʤ
 * ʤȤΤϤƤ
 *
 * Revision 1.3  1996/11/07  21:11:49  night
 * Version ֹϤȤ˺Ǹ˲ԤϤ褦ѹ
 *
 * Revision 1.2  1996/11/07  12:46:38  night
 * ƥॳ
 *
 * Revision 1.1  1996/11/05  15:13:45  night
 * ǽϿ
 *
 */

#include "posix.h"


/*
 * POSIX Ķޥ͡Υᥤ롼
 *
 * νԤ
 *
 * 
 *   ݡȥޥ͡׵դѤΥݡȤϿ
 *   ե륷ƥ/ץ/γƽνԤ
 *
 * ׵μդ
 *   ׵μդϡ׵դݡȤˤäƹԤ
 *
 * ׵ν
 *
 *   ׵μĤޤǤ¾׵ϼդʤ
 */
void
posix_start (void)
{
  struct posix_request	request;
#if 0
  extern B		_end;
#endif

  if (init_port () == FAIL)
    {
      dbg_printf ("Cannot allocate port.\n");
      slp_tsk ();
    }
  init_log ();
#if 0
  /* ǤϥץκǸȤ뤳ȤϤǤʤ */
  init_malloc ((UW)&_end);
#else
  /* ;͵򸫤ꤷƤ뤬manager 礭ʤäȤˤĴɬ */
  init_malloc (0x100000);
#endif

  /* Ƶǽñ̤Ǥν
   */
  init_fs ();
  init_process ();
  init_memory ();

  banner ();

  for (;;)
    {
      /* ׵åԤ */
      if (get_request (&request) == FAIL)
	{
	  /* ꥯȼ˼Ԥ */
#ifdef DEBUG
	  dbg_printf ("Cannot get request.\n");
#endif
	  continue;
	}

#ifdef DEBUG
      dbg_printf ("OP = %d\n ", request.operation);
#endif

      /* ꥯȤ */
      if ((request.operation < 0) || (request.operation > NR_POSIX_SYSCALL))
	{
	  /* ꥯ׵ˤ륪ڥ졼ϡݡȤƤʤ */
	  error_response (&request, EP_NOSUP);
	}
      else
	{
#ifdef DEBUG
	  dbg_printf ("systemcall: %s\n", syscall_table[request.operation].name);
#endif

	   (*syscall_table[request.operation].syscall)(&request);
	}
#ifdef DEBUG
      dbg_printf ("posix: systemcall end.\n");
#endif
    }
  /* ˤʤ */
}


void
banner (void)
{
  extern char	*posix_version;
  ID		taskid;
#ifdef notdef
  W	      	pid, low, hi;
  static B     	num[] = "0123456789";
  static B     	buf[3];
#endif

  dbg_printf ("POSIX Manager ver %s started.", posix_version);
  if (get_tid (&taskid) == E_OK)
    {
#ifdef notdef
      low = pid % 10;
      hi = pid / 10;
      buf[0] = num[hi];
      buf[1] = num[low];
      buf[2] = '\0';
      printk ("(TASK ID = %d  / PID = %s)", taskid, buf);
#else
      dbg_printf ("(TASK ID = %d)", taskid);
#endif
    }
  dbg_printf ("\n");
}


